ICUCollationAttributeFactory (Lucene 10.5.0 icu API)
Description: declaration: package: org.apache.lucene.analysis.icu, class: ICUCollationAttributeFactory

Package org.apache.lucene.analysis.icu

# Class ICUCollationAttributeFactory

java.lang.Object
org.apache.lucene.util.AttributeFactory
org.apache.lucene.util.AttributeFactory.StaticImplementationAttributeFactory<ICUCollatedTermAttributeImpl>
org.apache.lucene.analysis.icu.ICUCollationAttributeFactory

public class ICUCollationAttributeFactory extends AttributeFactory.StaticImplementationAttributeFactory<ICUCollatedTermAttributeImpl>
Converts each token into its `CollationKey`, and then encodes bytes as an index term.

WARNING: Make sure you use exactly the same Collator at index and query time -- CollationKeys are only comparable when produced by the same Collator. `RuleBasedCollator`s are independently versioned, so it is safe to search against stored CollationKeys if the following are exactly the same (best practice is to store this information with the index and check that they remain the same at query time):

1. Collator version - see `Collator.getVersion()`
2. The collation strength used - see `Collator.setStrength(int)`

CollationKeys generated by ICU Collators are not compatible with those generated by java.text.Collators. Specifically, if you use ICUCollationAttributeFactory to generate index terms, do not use `CollationAttributeFactory` on the query side, or vice versa.

ICUCollationAttributeFactory is significantly faster and generates significantly shorter keys than CollationAttributeFactory. See http://site.icu-project.org/charts/collation-icu4j-sun for key generation timing and key length comparisons between ICU4J and java.text.Collator over several languages.

- ## Nested Class Summary

  ## Nested classes/interfaces inherited from class org.apache.lucene.util.AttributeFactory

  `AttributeFactory.StaticImplementationAttributeFactory<A extends AttributeImpl>`

- ## Field Summary

  ### Fields inherited from class org.apache.lucene.util.AttributeFactory

  `DEFAULT_ATTRIBUTE_FACTORY`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `ICUCollationAttributeFactory(com.ibm.icu.text.Collator collator)`
  Create an ICUCollationAttributeFactory, using `TokenStream.DEFAULT_TOKEN_ATTRIBUTE_FACTORY` as the factory for all other attributes.
  `ICUCollationAttributeFactory(AttributeFactory delegate, com.ibm.icu.text.Collator collator)`
  Create an ICUCollationAttributeFactory, using the supplied Attribute Factory as the factory for all other attributes.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `ICUCollatedTermAttributeImpl`
  `createInstance()`

  ### Methods inherited from class org.apache.lucene.util.AttributeFactory.StaticImplementationAttributeFactory

  `createAttributeInstance, equals, hashCode`

  ### Methods inherited from class org.apache.lucene.util.AttributeFactory

  `getStaticImplementation`

  ### Methods inherited from class java.lang.Object

  `clone, finalize, getClass, notify, notifyAll, toString, wait, wait, wait`

- ## Constructor Details

  - ### ICUCollationAttributeFactory

    public ICUCollationAttributeFactory(com.ibm.icu.text.Collator collator)
    Create an ICUCollationAttributeFactory, using `TokenStream.DEFAULT_TOKEN_ATTRIBUTE_FACTORY` as the factory for all other attributes.
    Parameters:
      `collator` - CollationKey generator

  - ### ICUCollationAttributeFactory

    public ICUCollationAttributeFactory(AttributeFactory delegate, com.ibm.icu.text.Collator collator)
    Create an ICUCollationAttributeFactory, using the supplied Attribute Factory as the factory for all other attributes.
    Parameters:
      `delegate` - Attribute Factory
      `collator` - CollationKey generator

- ## Method Details

  - ### createInstance

    public ICUCollatedTermAttributeImpl createInstance()
    Specified by:
      `createInstance` in class `AttributeFactory.StaticImplementationAttributeFactory<ICUCollatedTermAttributeImpl>`